//
//  RundenStoppuhrViewController.m
//  RundenStoppuhr
//
//  Created by IMIMacBook2 on 19.09.11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "RundenStoppuhrViewController.h"

#define D_MINUTE	60
#define D_HOUR		3600
#define D_DAY		86400
#define D_WEEK		604800
#define D_YEAR		31556926
int millisec = 0;
int sec = 0;
int milliLastRound = 0;
long bestRound = 100000000;
BOOL timeRuns = FALSE;

@implementation RundenStoppuhrViewController

//@synthesize txtSetMeter, lblTimeGesamt; //mache automatisch getter und setter


- (IBAction) submitStart{ 
	if(!timeRuns){
		myTicker = [NSTimer scheduledTimerWithTimeInterval:0.01 target:self selector:@selector(showAct) userInfo:nil repeats:YES];
		timeRuns = TRUE;
	}
}


- (IBAction) submitStop{
	
	
	if(timeRuns){
		[myTicker invalidate];
		timeRuns = FALSE;
	}
}

- (IBAction) submitReset{
	millisec = 0;
	sec = 0;
	milliLastRound = 0;
	bestRound = 100000000;
	
	lblTimeGesamt.text = @"00:00.00";
	lblTimeThis.text = @"00:00.00";
	lblMeterGesamt.text = @"0";
	txtSetMeter.text = @"";
	lblRound.text = @"0";
	lblKmh.text = @"0";
	lblTimeRound.text = @"00:00.00";
	lblBestRound.text = @"00:00.00";
	
}

- (IBAction) submitNextRound{

	int round = [lblRound.text intValue];
	int newRound = round + 1;
	lblRound.text = [NSString stringWithFormat: @"%d", newRound];
	
	int meter = [txtSetMeter.text intValue];
	int meterGesamt = meter * newRound;
	lblMeterGesamt.text = [NSString stringWithFormat: @"%d", meterGesamt];
	
	
	//Durchschnittsrunde Runde
	int averageMillisec = millisec / newRound;
	int averageSec = (averageMillisec/100);
	
	int minutes = averageSec/60;
	int secundes = (int)(averageSec % 60);
	int millisecundes = (int)(averageMillisec % 100);	
	
	lblTimeRound.text = [NSString stringWithFormat: @"%02d:%02d.%02d", minutes, secundes, millisecundes];
	
	//Beste Runde
	if (millisec - milliLastRound < bestRound){
		bestRound = millisec - milliLastRound;
		int bestSec = (bestRound/100);
		minutes = bestSec/60;
		secundes = (int)(bestSec % 60);
		millisecundes = (int)(bestRound % 100);	
		
		lblBestRound.text = [NSString stringWithFormat: @"%02d:%02d.%02d", minutes, secundes, millisecundes];
	}
	
	milliLastRound = millisec;
	if(meter > 0 && sec > 0){
		float fMeter = [lblMeterGesamt.text floatValue];
		float fSecundes = (float) sec;
		float h=fSecundes/3600;
		float kmH = (fMeter/1000.0)/h;
		lblKmh.text = [NSString stringWithFormat:@"%.2f",kmH];
	}
}

- (IBAction) submitSetMeter{
	[txtSetMeter resignFirstResponder];
	
	int meter = [txtSetMeter.text intValue];
	int round = [lblRound.text intValue];
	int meterGesamt = meter * round;
	lblMeterGesamt.text = [NSString stringWithFormat: @"%d", meterGesamt];
	
	if(meter > 0 && sec > 0){
		float fMeter = [lblMeterGesamt.text floatValue];
		float fSecundes = (float) sec;
		float h=fSecundes/3600;
		float kmH = (fMeter/1000.0)/h;
		lblKmh.text = [NSString stringWithFormat:@"%.2f",kmH];
	}
}

- (void) showAct{
	//int currentTime = [lblTimeGesamt.text intValue];
	//int newTime = currentTime + 1;
	millisec = millisec + 1;
	sec = (millisec/100);
	
	int minutes = sec/60;
	int secundes = (int)(sec % 60);
	int millisecundes = (int)(millisec % 100);	
	
	lblTimeGesamt.text = [NSString stringWithFormat: @"%02d:%02d.%02d", minutes, secundes, millisecundes];
	
	
	int milliThis = millisec - milliLastRound;
	int secThis = (milliThis/100);
	
	minutes = secThis/60;
	secundes = (int)(secThis % 60);
	millisecundes = (int)(milliThis % 100);	
	
	lblTimeThis.text = [NSString stringWithFormat: @"%02d:%02d.%02d", minutes, secundes, millisecundes];

}


- (IBAction) keysWeg:(id)sender{
	// Methode damit Tastatur weggeht (wenn rechter unterer Button gedrückt wird)
	[sender resignFirstResponder];
}

- (IBAction) keysWegBackground:(id)sender{
	// Methode damit Tastatur weggeht, wenn auf Hintergrund geklickt wird
	[txtSetMeter resignFirstResponder];
}

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
